transport dynamic modules
[exim.git] / src / scripts / Configure-Makefile
1 #! /bin/sh
2 # Shell script to build Makefile in a build directory. It must be called
3 # from inside the directory. It does its own checking of when to rebuild; it
4 # just got too horrendous to get it right in "make", because of the optionally
5 # existing configuration files.
6 #
7 # Copyright (c) The Exim Maintainers 1995 - 2024
8 # SPDX-License-Identifier: GPL-2.0-or-later
9
10
11 LC_ALL=C
12 export LC_ALL
13 set -e
14
15
16 # First off, get the OS type, and check that there is a make file for it.
17
18 ostype=`../scripts/os-type -generic` || exit 1
19
20 if [ ! -r ../OS/Makefile-$ostype ] ; then
21   echo ""
22   echo "*** Sorry - operating system $ostype is not supported"
23   echo "*** See OS/Makefile-* for supported systems" 1>&2
24   echo ""
25   exit 1
26 fi
27
28 # We also need the architecture type, in order to test for any architecture-
29 # specific configuration files.
30
31 archtype=`../scripts/arch-type` || exit 1
32
33 # Now test for either the non-existence of Makefile, or for any of its
34 # components being newer. Note that the "newer" script gives the right
35 # answer (for our purposes) when the first file is non-existent.
36
37 editme=../Local/Makefile
38 rebuild=yes
39
40 if [ -f Makefile ] ; then
41   rebuild=no
42   if ../scripts/newer $editme Makefile || \
43      ../scripts/newer $editme-$ostype Makefile || \
44      ../scripts/newer $editme-$archtype Makefile || \
45      ../scripts/newer $editme-$ostype-$archtype Makefile || \
46      ../scripts/newer ../scripts/Configure-Makefile Makefile || \
47      ../scripts/newer ../OS/Makefile-Base Makefile || \
48      ../scripts/newer ../OS/Makefile-Default Makefile
49   then
50     rebuild=yes
51   fi
52 fi
53
54 # If the "build" variable is set it means that a build name was explicitly
55 # given. Arrange to pick up a build-specific configuration file.
56
57 if [ "X$build" != "X" ] ; then
58   mfb=Local/Makefile-$build
59   if ../scripts/newer $editme-$build Makefile ; then
60     rebuild=yes
61   fi
62 else
63   mfb=
64 fi
65
66
67 # If Makefile is up-to-date, no need to rebuild it.
68
69 if [ $rebuild = no ] ; then
70   echo "\`Makefile' is up to date."
71   echo " "
72   exit
73 fi
74
75 # Makefile needs to be rebuilt in the current directory by joining
76 # the generic default makefile, the OS base makefile, and then local
77 # generic, OS-specific, architecture-specific, and OS+architecture-specific
78 # makefiles, if they exist. These files all contain macro definitions, with
79 # later definitions overriding earlier ones. Make a temporary file first, in
80 # case things go wrong. A second temporary is needed for sorting out the
81 # default Perl stuff. Use short macro names to save typing.
82
83 mf=Makefile
84 mft=$mf-t
85 mftt=$mf-tt
86 mftepcp=$mf-tepcp
87 mftepcp2=$mf-tepcp2
88
89 look_mf=lookups/Makefile
90 look_mf_pre=${look_mf}.predynamic
91 look_mf_post=${look_mf}.postdynamic
92
93 # Ensure the temporary does not exist and start the new one by setting
94 # the OSTYPE and ARCHTYPE variables.
95
96 rm -f $mft $mftt $mftepcp $mftepcp2 $look_mf-t
97 (echo "OSTYPE=$ostype"; echo "ARCHTYPE=$archtype"; echo "") > $mft || exit 1
98
99 # Now concatenate the files to the temporary file. Copy the files using sed to
100 # remove comments, blank lines, and trailing white space.
101
102 # BEWARE: a tab character is needed in the sed command below. It has had
103 # a nasty tendency to get lost in the past, causing a problem if a tab has
104 # actually been present in one of the files. Use a variable to hold a space
105 # and a tab to keep the tab in one place.
106
107 st='     '
108
109 for f in OS/Makefile-Default \
110          OS/Makefile-$ostype \
111          Local/Makefile \
112          Local/Makefile-$ostype \
113          Local/Makefile-$archtype \
114          Local/Makefile-$ostype-$archtype \
115          $mfb
116 do   if test -r ../$f
117      then   echo "# From $f"
118             sed "/^#/d;/^[$st]*\$/d;s/[$st]*\$//" ../$f || exit 1
119             echo "# End of $f"
120             echo ""
121      fi
122 done \
123      | sed 's/^TMPDIR=/EXIM_&/' \
124      >> $mft || exit 1
125
126 # handle PKG_CONFIG_PATH because we need it in our env, and we want to handle
127 # wildcards; note that this logic means all setting _appends_ values, never
128 # replacing; if that's a problem, we can revisit.
129 sed -n "s/^[$st]*PKG_CONFIG_PATH[$st]*[+]*=[$st]*//p" $mft | \
130   sed "s/[$st]*\$//" >> $mftepcp
131 if test -s ./$mftepcp
132 then
133   # expand any wildcards and strip spaces, to make it a real PATH-like variable
134   ( IFS=":${IFS-$st}"; for P in `cat ./$mftepcp`; do echo "$P"; done ) | xargs | sed "s/[$st]/:/g" >./$mftepcp2
135   sed "s/^/PKG_CONFIG_PATH='/" < ./$mftepcp2 | sed "s/\$/'/" > ./$mftepcp
136   . ./$mftepcp
137   export PKG_CONFIG_PATH
138   grep -E -v "^[$st]*PKG_CONFIG_PATH[$st]*=" ./$mft > ./$mftt
139   rm -f ./$mft
140   (
141     echo "# Collapsed PKG_CONFIG_PATH in build-prep:"
142     sed "s/'//g" ./$mftepcp
143     echo "# End of collapsed PKG_CONFIG_PATH"
144     echo ""
145     cat ./$mftt
146   ) > ./$mft
147   rm -f ./$mftt
148 fi
149 rm -f ./$mftepcp ./$mftepcp2
150
151 # handle pkg-config
152 # beware portability of extended regexps with sed.
153 grep -E "^[$st]*(AUTH|LOOKUP)_[A-Z0-9_]*[$st]*=[$st]*" $mft | \
154   sed "s/[$st]*=/='/" | \
155   sed "s/\$/'/" > $mftt
156 grep -E "^[$st]*((USE_(OPENSSL|GNUTLS)_PC)|SUPPORT_TLS|USE_GNUTLS|PCRE2?_CONFIG|AVOID_GNUTLS_PKCS11)[$st]*=[$st]*" $mft | \
157   sed "s/[$st]*=/='/" | \
158   sed "s/\$/'/" >> $mftt
159 if test -s $mftt
160 then
161   (
162   echo "# pkg-config fixups"
163   . ./$mftt
164   for var in `cut -d = -f 1 < $mftt`; do
165     case $var in
166
167       USE_*_PC)
168         eval "pc_value=\"\$$var\""
169         need_this=''
170         need_core=''
171         if [ ".$DISABLE_TLS" = .yes ]; then
172           # no TLS, not referencing
173           true
174         elif [ ".$var" = ".USE_GNUTLS_PC" ] && [ ".$USE_GNUTLS" != "." ]; then
175           need_this=t
176           need_core="gnutls-special"
177         elif [ ".$var" = ".USE_OPENSSL_PC" ] && [ ".$USE_GNUTLS" = "." ]; then
178           need_this=t
179           need_core=t
180         fi
181         if [ ".$need_this" != "." ]; then
182           tls_include=`pkg-config --cflags $pc_value`
183           if [ $? -ne 0 ]; then
184             echo >&2 "*** Missing pkg-config for package $pc_value (for Exim $var build option)"
185             exit 1
186           fi
187           tls_libs=`pkg-config --libs $pc_value`
188           echo "TLS_INCLUDE=$tls_include"
189           echo "TLS_LIBS=$tls_libs"
190           # With hash.h pulling crypto into the core, we need to also handle that
191           if [ ".$need_this" = ".t" ]; then
192             echo "CFLAGS += $tls_include"
193             echo "LDFLAGS += $tls_libs"
194           elif [ ".$need_this" = ".gnutls-special" ]; then
195             if pkg-config --atleast-version=2.10 gnutls ; then
196               echo "CFLAGS += $tls_include"
197               echo "LDFLAGS += $tls_libs"
198             else
199               echo "CFLAGS += `libgcrypt-config --cflags`"
200               echo "LDFLAGS += `libgcrypt-config --libs`"
201             fi
202           fi
203         fi
204         ;;
205
206       *_PC)
207         eval "pc_value=\"\$$var\""
208         base=`echo $var | sed 's/_PC$//'`
209         eval "basevalue=\"\$$base\""
210         if [ ".$basevalue" = "." ]; then
211           # not pulling in this module, _PC defined as default? Ignore
212           true
213         elif [ $basevalue = 2 ]; then
214           # module; handled in scripts/lookups-Makefile
215           true
216         else
217           # main binary
218           cflags=`pkg-config --cflags $pc_value`
219           if [ $? -ne 0 ]; then
220             echo >&2 "*** Missing pkg-config for package $pc_value (for Exim $var build option)"
221             exit 1
222           fi
223           libs=`pkg-config --libs $pc_value`
224           if [ "$var" != "${var#LOOKUP_}" ]; then
225             echo "LOOKUP_INCLUDE += $cflags"
226             echo "LOOKUP_LIBS += $libs"
227           elif [ "$var" != "${var#AUTH_}" ]; then
228             echo "CFLAGS += $cflags"
229             echo "AUTH_LIBS += $libs"
230           else
231             echo >&2 "Don't know how to handle pkg-config for $var"
232           fi
233         fi
234         ;;
235
236       PCRE_CONFIG)
237         case $PCRE_CONFIG in
238           yes|YES|y|Y)
239              echo >&2 "pcre is no longer supported; migrate to pcre2"
240              exit 1
241
242 #            cflags=`pcre-config --cflags`
243 #            if [ $? -ne 0 ]; then
244 #              echo >&2 "*** Missing pcre-config for regular expression support"
245 #              exit 1
246 #            fi
247 #            libs=`pcre-config --libs`
248 #            if [ ".$cflags" != "." ]; then
249 #              echo "INCLUDE += $cflags"
250 #            fi
251 #            echo "PCRE_LIBS=$libs"
252             ;;
253         esac
254         ;;
255
256       PCRE2_CONFIG)
257         case $PCRE2_CONFIG in
258           yes|YES|y|Y)
259             cflags=`pcre2-config --cflags`
260             if [ $? -ne 0 ]; then
261               echo >&2 "*** Missing pcre2-config for regular expression support"
262               exit 1
263             fi
264             libs=`pcre2-config --libs8`
265             if [ ".$cflags" != "." ]; then
266               echo "INCLUDE += $cflags"
267             fi
268             echo "PCRE_LIBS=$libs"
269             ;;
270         esac
271         ;;
272
273       AVOID_GNUTLS_PKCS11)
274         echo "$var=yes"
275         ;;
276
277     esac
278   done
279   echo "# End of pkg-config fixups"
280   echo
281   ) >> $mft
282   subexit=$?
283   if [ $subexit -ne 0 ]; then
284     exit $subexit
285   fi
286 fi
287 rm -f $mftt
288
289 # make the lookups Makefile with the definitions
290 # the auxiliary script generates $look_mf_post from $look_mf_pre
291
292 cp ../src/lookups/Makefile $look_mf_pre
293 ../scripts/lookups-Makefile
294
295 while read class classdef names
296 do
297   cp ../src/$class/Makefile $class/Makefile.predynamic
298   CLASS=$class CLASSDEF=$classdef DRNAMES="$names" ../scripts/drivers-Makefile
299   mv $class/Makefile.postdynamic $class/Makefile
300   rm $class/Makefile.predynamic
301 done <<-END
302  routers ROUTER         ACCEPT DNSLOOKUP IPLITERAL IPLOOKUP MANUALROUTE QUERYPROGRAM REDIRECT
303  transports TRANSPORT   APPENDFILE AUTOREPLY LMTP PIPE QUEUEFILE SMTP
304 END
305
306 # See if there is a definition of EXIM_PERL in what we have built so far.
307 # If so, run Perl to find the default values for PERL_CC, PERL_CCOPTS,
308 # and PERL_LIBS. These need to be put at the top of the Makefile, so we rename
309 # what we have so far and then copy it afterwards. Use the value of PERL_COMMAND
310 # if it has been defined.
311
312 EXIM_PERL=`grep EXIM_PERL $mft`
313
314 PERL_COMMAND=`grep PERL_COMMAND $mft | sed -e "\\$!d;s/^[$st]*PERL_COMMAND[$st]*=[$st]*//"`
315 if [ "${PERL_COMMAND}" = "" ] ; then
316   PERL_COMMAND='perl'
317 fi
318
319 if [ "${EXIM_PERL}" != "" ] ; then
320   testperl=`$PERL_COMMAND --version`
321   if [ "$testperl" = "" ] ; then
322     echo "*** EXIM_PERL is set, but '$PERL_COMMAND --version' failed"
323     exit 1
324   fi
325
326   EXTUTILS_EMBED_NOT_INSTALLED=`$PERL_COMMAND -MExtUtils::Embed -e ";" 2>&1`
327   if [ "${EXTUTILS_EMBED_NOT_INSTALLED}" != "" ] ; then
328     echo "Please install ExtUtils::Embed for $PERL_COMMAND"
329     exit 1;
330   fi
331
332   mv $mft $mftt
333   echo "PERL_CC=`$PERL_COMMAND -MConfig -e 'print $Config{cc}'`" >>$mft
334   echo "PERL_CCOPTS=`$PERL_COMMAND -MExtUtils::Embed -e ccopts`" >>$mft
335   echo "PERL_LIBS=`$PERL_COMMAND -MExtUtils::Embed -e ldopts`" >>$mft
336   echo "" >>$mft
337   cat $mftt >> $mft
338   rm -f $mftt
339 fi
340
341 # Record the build variable in the Makefile.
342
343 echo "build=$build" >>$mft
344 echo "" >>$mft
345
346 # Finally, join on the generic base make file, which contains the actual
347 # rules and stuff.
348
349 echo "# From ../OS/Makefile-Base" >> $mft
350 cat ../OS/Makefile-Base >> $mft || exit 1
351
352 # If the new makefile is the same as the existing one, say so, and just
353 # update the timestamp. Otherwise remove the old and install the new.
354
355 if      [ -s $mf ] && cmp -s $mft $mf && [ -s $look_mf ] && cmp -s $look_mf_post $look_mf
356 then    echo ">>> rebuilt $mf unchanged"
357         echo " "
358         touch $mf || exit
359         rm -f $mft $look_mf_pre $look_mf_post
360 elif    rm -f $mf $look_mf $look_mf_pre
361         mv $mft $mf
362         mv $look_mf_post $look_mf
363 then    echo ">>> New $mf & $look_mf installed"
364         echo '>>> Use "make makefile" if you need to force rebuilding of the makefile'
365         echo " "
366 else    echo " "
367         echo "*** Failed to install $mf - see $mft"
368         echo "    (or $look_mft)"
369         echo " "
370         exit 1;
371 fi
372
373 # vim: set ft=sh :
374 # End of Configure-Makefile